package com.company.rowlevelerror.screen.note

import io.jmix.ui.screen.*
import com.company.rowlevelerror.entity.Note
import io.jmix.core.DataManager
import io.jmix.core.SaveContext
import io.jmix.core.UnconstrainedDataManager
import io.jmix.core.security.CurrentAuthentication
import io.jmix.ui.component.Button
import org.springframework.beans.factory.annotation.Autowired
import java.text.SimpleDateFormat
import java.util.*
import com.company.rowlevelerror.entity.User

@UiController("Note.browse")
@UiDescriptor("note-browse.xml")
@LookupComponent("notesTable")
class NoteBrowse : StandardLookup<Note>() {
    @Autowired
    private lateinit var currentAuthentication: CurrentAuthentication

    @Autowired
    private lateinit var unconstrainedDataManager: UnconstrainedDataManager

    @Subscribe("generate100")
    private fun onGenerate100Click(event: Button.ClickEvent) {
        val saveContext = SaveContext().setDiscardSaved(true)
        for (i in 1..100) {
            val note = unconstrainedDataManager.create(Note::class.java)
            note.noteText = getRandomString(10)
            note.assignedTo = currentAuthentication.user as User
            saveContext.saving(note)
            unconstrainedDataManager.save(saveContext)
        }
    }

    private fun getRandomString(length: Int) : String {
        val charset = ('a'..'z') + (' ')

        return List(length) { charset.random() }
            .joinToString("")
            .replaceFirstChar { it.titlecase(Locale.getDefault()) }
    }
}